!!ARBfp1.0

ATTRIB iColor = fragment.color.primary;
ATTRIB iCoord = fragment.texcoord;

PARAM lightvec = program.local[0]; # xyz: light vector; w: shadow alpha;
PARAM specdesc = program.local[1]; # x: specular alpha; y: shine;

OUTPUT oColor = result.color;

#---------#
# Program #
#---------#

TEMP light;
MOV light, lightvec;
DP3 light.w, light, light;
RSQ light.w, light.w;
MUL light.xyz, light, light.w;
TEMP eyevec;
MOV eyevec.xy, 0.0;
MOV eyevec.z, 1.0;

# diffuse color
TEMP samp;
TXP samp, iCoord, texture[0], 2D;
TEMP src;
MUL src, samp, iColor;

# bump map
TEMP bump;
TXP bump, iCoord, texture[1], 2D;
MUL bump.x, bump.x, 2.0;
MUL bump.y, bump.y, 2.0;
ADD bump.x, bump.x, -1.0;
ADD bump.y, bump.y, -1.0;
MOV bump.y, -bump.y;
TEMP temp;
MOV temp, 0.0;
MOV temp.x, bump.x;
MOV temp.y, bump.y;
DP3 temp, temp, temp;
MOV bump.z, temp.z;
ADD bump.z, 1.0, -bump.z;
RSQ bump.z, bump.z;
RCP bump.z, bump.z;

# attenuation
TEMP att;
MAX att, 0.0, lightvec.z;
ADD att, 1.0, -att;
MUL att, att, att;
ADD att, 1.0, -att;

# diffuse intensivity
TEMP diffint;
DP3 diffint, light, bump;
MOV_SAT diffint, diffint;

# specular intensivity
TEMP h;
ADD h, light, eyevec;
DP3 h.w, h, h;
RSQ h.w, h.w;
MUL h.xyz, h, h.w;
TEMP specint;
DP3 specint, h, bump;
MOV_SAT specint, specint;
POW specint, specint.w, specdesc.y;

# result
TEMP out;
MUL out, src, diffint;
MUL out, out, att;

MUL out, out, lightvec.w;
TEMP tmp;
ADD tmp, 1.0, -lightvec.w;
MUL src, src, tmp;
ADD out, src, out;

TEMP t;
MUL t, iColor, specint;
MUL t, t, specdesc.x;
ADD out, out, t;

# set output
MOV oColor, out;

END