!!ARBfp1.0

ATTRIB iColor = fragment.color.primary;
#ATTRIB iColorSec = fragment.color.secondary;
ATTRIB iCoord = fragment.texcoord;
#ATTRIB iCoordFog = fragment.fogcoord;
#ATTRIB iPosition = fragment.position;

PARAM refdesc = program.local[0]; # x: relative X; y: relative Y; z: refract scale; 

OUTPUT oColor = result.color;
#OUTPUT oDepth = result.depth;

#---------#
# Program #
#---------#

TEMP eyevec;
MOV eyevec.xy, 0.0;
MOV eyevec.z, -1.0;
TEMP lightvec;
MOV lightvec.xy, 0.0;
MOV lightvec.z, 1.0;

# normal map
TEMP pos;
ADD pos, iCoord, refdesc;
MOV pos.w, 1.0;
TEMP bump;
TXP bump, pos, texture[1], 2D;
MUL bump.x, bump.x, 2.0;
MUL bump.y, bump.y, 2.0;
ADD bump.x, bump.x, -1.0;
ADD bump.y, bump.y, -1.0;
MOV bump.y, -bump.y;
TEMP temp;
MOV temp, 0.0;
MOV temp.x, bump.x;
MOV temp.y, bump.y;
DP3 temp, temp, temp;
MOV bump.z, temp.z;
ADD bump.z, 1.0, -bump.z;
RSQ bump.z, bump.z;
RCP bump.z, bump.z;

# attenuation
TEMP att;
MAX att, 0.0, lightvec.z;
ADD att, 1.0, -att;
MUL att, att, att;

# refract
TEMP refract;
DP3 refract, lightvec, bump;
MOV_SAT refract, refract;
MUL bump, bump, refract;
MUL bump, bump, refdesc.z;
ADD bump, iCoord, bump;

# diffuse color
TEMP samp;
TXP samp, bump, texture[0], 2D;
TEMP out;
MUL out, samp, iColor;

# set output
MOV oColor, out;

END